package com.ruoyi.agentcenter.listener;

import com.alibaba.fastjson2.JSONObject;
import com.google.common.eventbus.Subscribe;
import com.nsgk.agentcentersdk.entity.NSContractionEntity;
import com.ruoyi.agentcenter.domain.TAgentContraction;
import com.ruoyi.agentcenter.object.ContractionSession;
import com.ruoyi.agentcenter.object.Message;
import com.ruoyi.agentcenter.object.Result;
import com.ruoyi.agentcenter.service.ITAgentContractionService;
import com.ruoyi.common.utils.EventBusEngine;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.Date;

@Component
public class ContractionListener
{
    @Autowired
    private ITAgentContractionService itAgentContractionService;

    @PostConstruct
    public void init()
    {
        EventBusEngine.Register(this);
    }

    @Subscribe
    //@AllowConcurrentEvents
    public void handle(ContractionSession session)
    {
        TAgentContraction contraction = conv(session.message);
        Result result = session.result;

        itAgentContractionService.insertTAgentContraction(contraction);

        result.setData(contraction);
    }

    private TAgentContraction conv(Message<NSContractionEntity> message)
    {
        TAgentContraction contraction = new TAgentContraction();
        NSContractionEntity data = message.getData();
        contraction.setBookId(data.getBookId())
                .setDeptId(data.getDeptId())
                .setOutId(data.getOutId())
                .setOrgCode(data.getOrgCode())
                .setName(data.getName())
                .setBuildingTime(data.getBuildingTime())
                .setOrderAt(new Date())
                .setAgentStatus("1")
                .setOrderStatus("2")
                .normalized();
                ;
        return contraction;
    }
}
